<template>
    <div>
        <button 
            v-if="authUser && authUser.id != profile.id && !isFollowing" 
            @click="follow" 
            class="bg-white text-blue-500 font-bold rounded-full py-2 px-4 border border-blue-500 hover:bg-blue-100 transition ease-in-out duration-150 focus:outline-none"
        >
            Follow
        </button>

        <button 
            v-if="authUser && authUser.id != profile.id && isFollowing" 
            @click="unfollow"
            @mouseover="buttonText = 'Unfollow'"
            @mouseleave="buttonText = 'Following'"
            class="bg-blue-500 w-25 text-center text-white font-bold rounded-full py-2 px-4 border-blue-500 hover:bg-red-600 transition ease-in-out duration-150 focus:outline-none"
        >
            {{ buttonText }}
        </button>
    </div>
</template>
<script>
import { mapGetters, mapActions } from 'vuex';
export default {
    props: {
        profile: {
            required: true,
            type: Object
        }
    },
    
    data() {
        return {
            authUser: null,
            buttonText: 'Following'
        }
    },

    computed: {
        ...mapGetters({
            followers: 'profile/followers'
        }),

        isFollowing() {
            return this.followers.includes(this.profile.id);
        }
    },

    methods: {
        ...mapActions({
            followProfile: 'profile/followProfile',
            unfollowProfile: 'profile/unfollowProfile'
        }),

        follow() {
            this.followProfile(this.profile.user.username);
        },

        unfollow() {
            this.unfollowProfile(this.profile.user.username);
            return;
        },

        authCheck() {
            if(window.User) {
                this.authUser = window.User;
            }
        }
    },

    mounted() {
        this.authCheck();
    },
}
</script>